You can not select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.
 
 
 
 
 
 

1322 lines
30 KiB

  1. #!/bin/sh
  2. # TODO: decide the naming scheme of variables (global, local, ...)
  3. expr "$-" : '^.*i' >/dev/null || return
  4. ##########################################
  5. __shrc_lock=/tmp/shrc_lock.$USER.$$
  6. test -f "$__shrc_lock" && return
  7. touch "$__shrc_lock"
  8. ##########################################
  9. null(){
  10. "$@" >/dev/null 2>&1
  11. }
  12. __safe_run(){
  13. type $1 >/dev/null 2>&1 && "$@"
  14. }
  15. __match(){
  16. # __match str word
  17. # return 0 if word is found in str
  18. expr "$1" : ".*$2.*" >/dev/null
  19. }
  20. __lf=$'\n'
  21. __cr=$'\r'
  22. test -n "$TMP" || export TMP=/tmp/${USER}-tmp
  23. mkdir -p "$TMP"
  24. __homerun="$HOME/.var/run"
  25. mkdir -p "$__homerun"
  26. ##########################
  27. # system type
  28. gnu_coreutils=false # for mac
  29. null ls --version && gnu_coreutils=true
  30. inbash=false
  31. inzsh=false
  32. if test -n "$BASH_VERSION"
  33. then
  34. inbash=true
  35. elif test -n "$ZSH_VERSION"
  36. then
  37. inzsh=true
  38. fi
  39. #################################
  40. # file pathes:
  41. # shrc: Path to this file
  42. if $inbash
  43. then
  44. __shrc="$BASH_SOURCE"
  45. elif $inzsh
  46. then
  47. __shrc="$0"
  48. fi
  49. #########################
  50. # system detection
  51. __system_shrc="$__homerun/system.shrc"
  52. if test -f "$__system_shrc"
  53. then
  54. . "$__system_shrc"
  55. else
  56. ismsys=false
  57. iscygwin=false
  58. iswindows=false
  59. isdarwin=false
  60. isfreebsd=false
  61. isbsd=false
  62. islinux=false
  63. # $OSTYPE is another choice. which is better?
  64. # NOTE: sh on FreeBSD does not define OSTYPE
  65. case `uname` in
  66. MINGW*) ismsys=true ;;
  67. CYGWIN*) iscygwin=true ;;
  68. Darwin*) isdarwin=true ;;
  69. FreeBSD*) isfreebsd=true ;;
  70. Linux*) islinux=true ;;
  71. esac
  72. ($ismsys || $iscygwin) && iswindows=true
  73. # is this true?
  74. ($isdarwin || $isfreebsd) && isbsd=true
  75. # dump system detection result
  76. cat <<__EOC__ >"$__system_shrc"
  77. #!/bin/sh
  78. # $__system_shrc
  79. ismsys=$ismsys
  80. iscygwin=$iscygwin
  81. iswindows=$iswindows
  82. isdarwin=$isdarwin
  83. isfreebsd=$isfreebsd
  84. isbsd=$isbsd
  85. islinux=$islinux
  86. __EOC__
  87. fi
  88. $ismsys && export HOSTNAME
  89. # adhoc fix for ansible on cygwin
  90. # http://blog.s-uni.net/2013/08/27/ansible-running-on-cygwin/
  91. if $iscygwin
  92. then
  93. export ANSIBLE_SSH_ARGS="-o ControlMaster=no"
  94. fi
  95. ##########################
  96. # Terminal setups
  97. if ! $iswindows && null type stty
  98. then
  99. stty stop undef # unbind C-s to stop displaying output
  100. # stty erase '^h'
  101. fi
  102. # Zsh specific preferences
  103. # http://www.clear-code.com/blog/2011/9/5.html
  104. if $inzsh
  105. then
  106. bindkey -e
  107. # http://zsh.sourceforge.net/Guide/zshguide06.html#l147
  108. autoload compinit; compinit
  109. # supress cycle by tab
  110. unsetopt auto_menu
  111. # unsetopt correct
  112. setopt complete_aliases
  113. setopt auto_list
  114. setopt bash_auto_list
  115. setopt magic_equal_subst
  116. setopt list_types
  117. # what is the difference of these two?
  118. setopt auto_param_slash
  119. setopt mark_dirs
  120. zstyle ':completion:*' list-colors ${(s.:.)LS_COLORS}
  121. zstyle ':completion:*' format '%B%d%b'
  122. zstyle ':completion:*' group-name ''
  123. zstyle ':completion:*' use-cache yes
  124. # zstyle ':completion:*:cd:*' tag-order local-directories
  125. zstyle ':completion:*' completer _complete _bash_completions \
  126. _history
  127. # zstyle ':completion:*:*:cd:*' completer
  128. zstyle ':completion:*' accept-exact-dirs true
  129. zstyle ':completion:*' special-dirs true
  130. autoload colors; colors
  131. # autoload -Uz promptinit
  132. # promptinit
  133. # prompt walters
  134. setopt hist_ignore_dups
  135. setopt hist_ignore_all_dups
  136. setopt hist_save_no_dups
  137. setopt extended_history
  138. setopt share_history
  139. setopt append_history
  140. HISTFILE=$HOME/.zsh-history
  141. HISTSIZE=100000
  142. SAVEHIST=100000
  143. setopt prompt_subst
  144. setopt interactive_comments
  145. fi
  146. ######################
  147. # Print welcome messages
  148. command -v fortune >/dev/null && {
  149. if command -v cowsay >/dev/null
  150. then
  151. fortune | cowsay
  152. echo
  153. fortune -o | cowsay
  154. echo
  155. else
  156. fortune
  157. echo
  158. fortune -o
  159. echo
  160. fi
  161. }
  162. if null type figlet && null type lolcat
  163. then
  164. hostname -s | figlet | lolcat
  165. fi
  166. uname -a
  167. $iswindows && alias tty="echo cmd.exe"
  168. echo TERM $TERM with $(tput colors) colors using $(tty)
  169. echo umask: `umask -S`
  170. echo
  171. __safe_run w yuk
  172. # if null type tmux
  173. # then
  174. # echo
  175. # echo tmux sessions:
  176. # tmux ls 2>/dev/null| sed -e 's/^/ /g'
  177. # echo
  178. # fi
  179. # if test -n "$TMUX"
  180. # then
  181. # tmux display -p \
  182. # 'TMUX #S:#I:#W.#P, client TERM: #{client_termname}' \
  183. # 2>/dev/null
  184. # echo
  185. # fi
  186. if test -n "$__MY_DTACH"
  187. then
  188. echo
  189. echo DSession: Current Session: "`basename "$__MY_DTACH"`"
  190. echo DSession: Press C-^ to Exit.
  191. true
  192. fi
  193. i(){
  194. w
  195. ss -lnp
  196. ps aufx
  197. df -h
  198. top -b -d 1 -n 1
  199. top -b -d 1 -n 1 -a
  200. dstat -taf 1 10
  201. }
  202. ###################################
  203. # some aliases and functions
  204. # __func_name: never used interactively
  205. # _func_name: usually not used interactively
  206. __safe_alias(){
  207. # __safe_alias <name>=<command>
  208. _bin=`expr "$1" : '^[^=]*=\([^ ]*\)'`
  209. test -n "$_bin" && \
  210. null type $_bin && \
  211. alias "$1"
  212. }
  213. $gnu_coreutils && _timeoption=" --time-style=long-iso"
  214. # color prefs
  215. if $gnu_coreutils
  216. then
  217. # http://qiita.com/yuyuchu3333/items/84fa4e051c3325098be3
  218. # gnu coreutils LS_COLORS is used
  219. null type dircolors && eval `dircolors`
  220. _coloroption=" --color=auto"
  221. else
  222. # export LSCOLORS=gxfxcxdxbxegedabagacad
  223. export LSCOLORS=DxGxcxdxCxegedabagacad
  224. export CLICOLOR=1
  225. fi
  226. alias ls="ls -hCF${_coloroption}${_timeoption}"
  227. _timeformat_iso="%Y-%m-%dT%H:%M:%S%z"
  228. _timeformat_rfc2822="%a, %d %b %Y %T %z"
  229. _timeformat_num="%Y%m%d%H%M%S"
  230. alias datenum="date +$_timeformat_num"
  231. alias less="less -FX"
  232. __safe_alias em="emacs -nw"
  233. test -n "$_VI_ALT" && alias vi=$_VI_ALT
  234. alias pstree="LANG=C pstree"
  235. alias cp="cp -v"
  236. alias mv="mv -v"
  237. alias rm="rm -v"
  238. alias mkdir="mkdir -v"
  239. $gnu_coreutils && alias rmdir="rmdir -v"
  240. alias psaux="ps auxww"
  241. alias modest="ionice -c 2 -n 7 nice -n 19"
  242. alias e=exec
  243. __safe_alias e3=e3em
  244. #alias dirs="dirs -v -l | \grep -v \$(printf '%s$' \$PWD)"
  245. alias po=popd
  246. alias pu=pushd
  247. __safe_alias sudo="sudo " # use aliases through sudo
  248. __safe_alias sudoe="sudoedit"
  249. __safe_alias make="nice make"
  250. __safe_alias brew="nice brew"
  251. __safe_alias gcc="nice gcc"
  252. __safe_alias go="nice go"
  253. __safe_alias git="nice git"
  254. __safe_alias javac="nice javac -J-Duser.language=en"
  255. alias rand="echo \$RANDOM"
  256. alias pycalc="python -i -c 'from math import *' "
  257. __safe_alias py3=python3
  258. __safe_alias py2=python2
  259. __safe_alias ipy=ipython
  260. __safe_alias ipy3=ipython3
  261. __safe_alias ipy2=ipython2
  262. __safe_alias rl=rlwrap
  263. __safe_alias igosh=gosh-rl
  264. # Sometimes SHELL cannot be used. For example, when running bash inside zsh
  265. # SHELL is set to be /bin/zsh
  266. if $inbash
  267. then
  268. alias _reloadrc="rm '$__shrc_lock'; exec bash"
  269. elif $inzsh
  270. then
  271. alias _reloadrc="rm '$__shrc_lock'; exec zsh"
  272. else
  273. alias _reloadrc="rm '$__shrc_lock'; exec $SHELL"
  274. fi
  275. # alias mytime="date +%Y%m%d-%H%M%S"
  276. alias sh="ENV=$HOME/.shrc PS1=\$\ PROMPT_COMMAND="" sh"
  277. # some extra utilities
  278. __safe_alias mpg123="mpg123 -C -v --title"
  279. #export PLAYER="mpg123 -C -v --title"
  280. __safe_alias screen="screen -e^z^z"
  281. #alias zcd="cd \`zenity --file-selection --directory\`"
  282. __safe_alias gtags="gtags --verbose"
  283. __safe_alias htags="htags --xhtml --symbol --line-number \
  284. --frame --alphabet --verbose"
  285. __safe_alias au=aunpack
  286. # __safe_alias lv="lv|less"
  287. __safe_alias rs="rsync --progress --itemize-changes --compress"
  288. __safe_alias vagr=vagrant
  289. __safe_alias ztw='twitter set "`zenity --entry --title ztw --text Status:`"'
  290. if $iscygwin
  291. then
  292. __my_wget_options=" --no-check-certificate"
  293. __safe_alias wget="wget $__my_wget_options"
  294. fi
  295. if $isdarwin
  296. then
  297. alias updatedb="LC_ALL=C updatedb"
  298. # do not use locate installed by macports
  299. test -x /usr/bin/locate && alias locate="/usr/bin/locate"
  300. fi
  301. # somehow not work
  302. # typeset -ga chpwd_functions
  303. # chpwd_functions+=pwd
  304. # chpwd(){
  305. # pwd
  306. # }
  307. cd(){
  308. builtin cd "$@" && pwd
  309. }
  310. root(){
  311. if test "`git rev-parse --is-inside-work-tree 2>/dev/null`" = true
  312. then
  313. cd "`git rev-parse --show-toplevel`"
  314. else
  315. cd /
  316. fi
  317. }
  318. __find_latest_vimdir(){
  319. vimdir=/usr/share/vim
  320. if test -d "$vimdir"
  321. then
  322. find "$vimdir" -name 'vim??' -type d | sort | tail -n 1
  323. else
  324. echo ""
  325. fi
  326. }
  327. for f in /usr/share/vim/vimcurrent "`__find_latest_vimdir`"
  328. do
  329. test -n "$f" || continue
  330. f="$f/macros/less.sh"
  331. test -f $f && alias vl=$f && break
  332. done
  333. __safe_alias pa="pacman --color=always"
  334. __safe_alias pa="pacmatic --color=always"
  335. __safe_alias pa="pacapt"
  336. __safe_alias yt=yaourt
  337. # variable for yaourt
  338. null type pacmatic && export PACMAN="pacmatic"
  339. __safe_alias cower="cower --color=auto"
  340. __my_pacman_update_mirrorlist_with_reflector(){
  341. f=/etc/pacman.d/mirrorlist
  342. cmd="$(expr "$(grep -m 1 reflector $f)" : '# With: *\(.*\)')"
  343. if test -z "$cmd"
  344. then
  345. cmd="reflector --verbose --number 5 --sort rate --protocol http --protocol https --save $f"
  346. fi
  347. echo ">>> $cmd ..." 1>&2
  348. sudo sh -c "$cmd" && cat $f
  349. }
  350. null type reflector && test -d /etc/pacman.d && \
  351. alias reflect_mirrorlist=__my_pacman_update_mirrorlist_with_reflector
  352. null type apt-get && {
  353. alias aupgrade="sudo sh -xc 'apt-get autoremove --yes && \
  354. apt-get update --yes && apt-get upgrade --yes'"
  355. alias aptin="apt-get install"
  356. alias aptsearch="apt-cache search"
  357. alias aptshow="apt-cache show"
  358. }
  359. null type port && {
  360. alias port="port -v"
  361. alias pupgrade="sudo sh -xc 'port -v selfupdate && \
  362. port -v upgrade outdated'"
  363. }
  364. if $iscygwin
  365. then
  366. null type windate || \
  367. alias windate="cmd.exe //c 'echo %DATE%-%TIME%'"
  368. # alias cygsu="cygstart /cygwinsetup.exe"
  369. fi
  370. mkpatch(){
  371. if test $# -eq 0
  372. then
  373. echo "usage: mkpatch <olddir> <newdir>"
  374. elif ! test -d "$1"
  375. then
  376. echo "mkpatch: $1 is not a directory"
  377. elif ! test -d "$2"
  378. then
  379. echo "mkpatch: $2 is not a directory"
  380. else
  381. diff -Naur "$1" "$2"
  382. fi
  383. }
  384. __sdcv_less(){
  385. command sdcv -n "$@" | less --quit-if-one-screen
  386. }
  387. command -v sdcv >/dev/null && alias dict=__sdcv_less
  388. g(){
  389. if test $# -eq 0 && null type git-info
  390. then
  391. git info
  392. else
  393. git "$@"
  394. fi
  395. }
  396. $isdarwin && $inbash && \
  397. . /Applications/Xcode.app/Contents/Developer/usr/share/git-core/git-completion.bash
  398. $isdarwin && $inzsh && \
  399. . /Applications/Xcode.app/Contents/Developer/usr/share/git-core/git-completion.zsh
  400. if null type _git && $inbash
  401. then
  402. # enable programmable completion for g
  403. complete -o bashdefault -o default -o nospace -F _git g 2>/dev/null \
  404. || complete -o default -o nospace -F _git g
  405. fi
  406. #git svn --help >/dev/null 2>&1 && alias gsvn="git svn"
  407. __safe_alias m=gitmemo
  408. #alias setup.py3="sudo python3 setup.py install --record files.txt"
  409. randomstr(){
  410. len=$1
  411. test -z "$len" && len=8
  412. uuidgen | tr -d - | cut -c 1-len
  413. }
  414. datestr(){
  415. # datestr YYYYMMDDhhmmss
  416. if test -z "$1" || test "$1" = "-h"
  417. then
  418. echo "datestr: usage: datestr <YYYYMMDDhhmmss>"
  419. return 1
  420. fi
  421. # actual format for date command
  422. dfmt="`echo "$1" | \
  423. sed -e 's/YYYY/%Y/g' -e 's/yyyy/%Y/g' -e 's/YY/%y/g' -e 's/yy/%y/g' |\
  424. sed -e 's/MM/%m/g' -e 's/DD/%d/g' -e 's/dd/%d/g' | \
  425. sed -e 's/HH/%H/g' -e 's/hh/%H/g' -e 's/mm/%M/g' -e 's/SS/%S/g' -e 's/ss/%S/g'`"
  426. date +"$dfmt"
  427. }
  428. # ssh(){
  429. # # __my_terminal_title ssh
  430. # command ssh "$@"
  431. # }
  432. __ssh_with_cd(){
  433. # __ssh_with_cd <host> <directory> [<arg> ...]
  434. if test -z "$2"
  435. then
  436. echo "usage: __ssh_with_cd <host> <directory> [<arg> ...]"
  437. return 1
  438. fi
  439. host="$1"
  440. shift
  441. dir="$1"
  442. shift
  443. ssh "$host" "$@" -t "cd \"$dir\"; \$SHELL -l"
  444. }
  445. memo(){
  446. if test -z "$1"
  447. then
  448. _memo="memo.txt"
  449. else
  450. _memo="$1/memo.txt"
  451. fi
  452. $EDITOR "$_memo"
  453. if test -z "`cat "$_memo"`"
  454. then
  455. echo "$_memo is empty. Removing."
  456. rm "$_memo"
  457. fi
  458. }
  459. now(){
  460. ___tformat="%Y/%m/%d %H:%M:%S %z"
  461. cal
  462. REPLY=
  463. printf "\\r`date "+${___tformat}"`"
  464. read -t 1
  465. while test $? -ne 0
  466. do
  467. printf "\\r`date "+${___tformat}"`"
  468. read -t 1
  469. done
  470. }
  471. s(){
  472. if git rev-parse --git-dir >/dev/null 2>&1
  473. then
  474. echo ">> git grep -n $@" 1>&2
  475. git grep -n "$@"
  476. elif which ag >/dev/null 2>&1
  477. then
  478. echo ">> ag --pager=\"$PAGER\" $@" 1>&2
  479. ag --pager="$PAGER" "$@"
  480. elif which ack >/dev/null 2>&1
  481. then
  482. echo ">> ack --pager=\"$PAGER\" $@" 1>&2
  483. ack --pager="$PAGER" "$@"
  484. else
  485. echo \
  486. ">> find . " \
  487. "-path '*/.git' -prune -o" \
  488. "-path '*/.svn' -prune -o" \
  489. "-type f -exec grep -nH -e --color=always $@ {} +" 1>&2
  490. if test $# -eq 0
  491. then
  492. echo "No search word given." 1>&2
  493. return 1
  494. fi
  495. find . \
  496. -path '*/.git' -prune -o \
  497. -path '*/.svn' -prune -o \
  498. -type -f -exec grep -nH -e --color=always "$@" {} + \
  499. | $PAGER
  500. fi
  501. }
  502. MYMANPATH='/usr/lib/erlang/man'
  503. if $inbash || $inzsh
  504. then
  505. man(){
  506. env \
  507. LESS_TERMCAP_mb=$(printf "\e[1;35m") \
  508. LESS_TERMCAP_md=$(printf "\e[1;31m") \
  509. LESS_TERMCAP_me=$(printf "\e[0m") \
  510. LESS_TERMCAP_se=$(printf "\e[0m") \
  511. LESS_TERMCAP_so=$(printf "\e[1;44;33m") \
  512. LESS_TERMCAP_ue=$(printf "\e[0m") \
  513. LESS_TERMCAP_us=$(printf "\e[1;32m") \
  514. MANPATH="`manpath`:$MYMANPATH" \
  515. man "$@"
  516. }
  517. fi
  518. netwait(){
  519. while ! ping -c 1 -t 1 example.com
  520. do
  521. true
  522. done
  523. echo network works.
  524. }
  525. __realpath(){
  526. if type realpath >/dev/null 2>&1
  527. then
  528. command realpath "$@"
  529. else
  530. while ! test -d $1
  531. do
  532. shift
  533. done
  534. (command cd "$d" && echo "$PWD")
  535. # local d="$OLDPWD"
  536. # command cd "$1"
  537. # echo "$PWD"
  538. # command cd "$d"
  539. fi
  540. }
  541. if $isdarwin
  542. then
  543. # I want to use env -u, but darwin env does not provide this option
  544. null type tmux && alias tmux='SHLVL= tmux'
  545. else
  546. null type tmux && alias tmux='env -u SHLVL tmux'
  547. fi
  548. tx(){
  549. tmux start-server
  550. if test -z "$1"
  551. then
  552. echo "usage: tx [<session_name>]"
  553. tmux list-sessions
  554. elif test -z "$TMUX"
  555. then
  556. # -A: attach if already exists
  557. # tmux new-session -A -c "$HOME" -s "$1"
  558. tmux new-session -A -s "$1"
  559. else
  560. # create new session if not exists yet
  561. # tmux has-session -t "$1" || TMUX= tmux new-session -d -c "$HOME" -s "$1"
  562. tmux has-session -t "$1" || TMUX= tmux new-session -d -s "$1"
  563. tmux switch-client -t "$1"
  564. fi
  565. }
  566. __dsession(){
  567. # dt [-h] [<name>] [<command ...>]
  568. __dtach_dir="${TMP}/dtach"
  569. mkdir -p "${__dtach_dir}"
  570. if test -n "${__MY_DTACH}"
  571. then
  572. # if already in dtach session print current session
  573. soc_name="`basename "$__MY_DTACH"`"
  574. echo "Current session: ${soc_name}"
  575. fi
  576. if test -z "$1"
  577. then
  578. # if no arg given show list of sessions
  579. echo "Usage: ds [<session>]"
  580. echo "Sessions:"
  581. ls "${__dtach_dir}"
  582. return 0
  583. elif test "$1" = "-h"
  584. then
  585. echo "dt: usage: dt [-h] [<name>] [<command ...>]" 1>&2
  586. return 1
  587. fi
  588. # set socket name
  589. soc_name="${__dtach_dir}/$1"
  590. shift
  591. if test -n "$__MY_DTACH"
  592. then
  593. echo "dtach session cannot be nested." 1>&2
  594. return 1
  595. elif test -S "$soc_name"
  596. then
  597. dtach -a "$soc_name" -e ^^
  598. elif test -e "$soc_name"
  599. then
  600. echo "dt: File named $soc_name already exists."
  601. return 1
  602. elif test -z "$1"
  603. then
  604. # if no command given invoke current shell
  605. __MY_DTACH="$soc_name" dtach -c "$soc_name" -e ^^ sh -c "$SHELL"
  606. # echo "dt: Socket named $soc_name not exists and no command specified."
  607. # return 1
  608. else
  609. __MY_DTACH="$soc_name" dtach -c "$soc_name" -e ^^ "$@"
  610. fi
  611. }
  612. null type dtach && alias ds=__dsession
  613. scr(){
  614. test -n "$1" && pf="${1}-"
  615. ___tformat="%Y%m%d-%H%M%S%z"
  616. ___file="${HOME}/${pf}`date +${___tformat}`.script"
  617. __MY_SCRIPT=${___file} script ${___file} "$@"
  618. }
  619. dtscr(){
  620. # dtscr <command ...>
  621. if test -z "$1"
  622. then
  623. echo "dtscr: usage: dtscr <command ...>"
  624. return 1
  625. fi
  626. ___cmdstr="`echo $@ | tr ' ' +`"
  627. ___tformat="%Y%m%d-%H%M%S%z"
  628. ___name="${pf}`date +${___tformat}`-${___cmdstr}"
  629. ___scr_file="${HOME}/${___name}.script"
  630. ___dt_dir="${TMP}/dtscr"
  631. mkdir -p "$___dt_dir"
  632. dtach -n "${___dt_dir}/${___name}" script "${___scr_file_}" "$@"
  633. # echo $_name
  634. # echo $_file
  635. }
  636. mcrypt_stream(){
  637. test $# -eq 2 || return 1
  638. case $1 in
  639. en)
  640. mcrypt --key $2 | base64 ;;
  641. de)
  642. base64 -d | mcrypt -d --key $2 ;;
  643. esac
  644. }
  645. gpg_stream(){
  646. test $# -eq 2 || return 1
  647. case $1 in
  648. en)
  649. gpg --passphrase $2 -c --batch |base64 ;;
  650. de)
  651. base64 -d|gpg --passphrase $2 -d --batch ;;
  652. esac
  653. }
  654. dgpg(){
  655. if test "$1" = help || test -z "$2"
  656. then
  657. echo "dgpg: dgpg <en|de> <src-suffix> [<dst-suffix>]" 1>&2
  658. return
  659. fi
  660. ___srcs="$2"
  661. ___dsts="$3"
  662. test -z "$___dsts" && ___dsts="${___srcs}.out"
  663. ___pw=
  664. echo -n "dgpg pw: "
  665. read -s ___pw
  666. echo ""
  667. test -z "$___pw" && return 1
  668. for f in *${___srcs}
  669. do
  670. ___d="$(basename "$f" "${___srcs}")${___dsts}"
  671. echo -n "Processing $f to $___d..."
  672. if test -d "$f"
  673. then
  674. echo "`printf 'failed (%s is directory)' $f`"
  675. elif test -f "$___d"
  676. then
  677. echo "`printf 'failed (%s is already exists)' $___d`"
  678. elif <"$f" gpg_stream $1 $___pw >"$___d" 2>/dev/null
  679. then
  680. echo "done"
  681. else
  682. echo "failed"
  683. test -f "$___d" && rm "$___d"
  684. fi
  685. done
  686. }
  687. alias enst="gpg_stream en"
  688. alias dest="gpg_stream de"
  689. showinfo(){
  690. echo "Japanese letters are 表示可能"
  691. __safe_run diskinfo
  692. ! $isdarwin && test -n "${DISPLAY}" && {
  693. __safe_run xrandr | \grep --color=never ^Screen
  694. }
  695. $iswindows || __safe_run finger $USER
  696. LANG=C __safe_runc id
  697. __safe_run xset q
  698. }
  699. x(){
  700. if [[ -z $DISPLAY ]] && ! [[ -e /tmp/.X11-unix/X0 ]] && (( EUID )); then
  701. #mkdir -p ~/.var/log
  702. # nohup startx >~/.var/log/xorg.log 2>&1 &
  703. # exit
  704. exec startx
  705. else
  706. echo "X cant be started! Another X is already running?" 1>&2
  707. fi
  708. }
  709. bak(){
  710. for file in "$@"
  711. do
  712. cp -v ${file} ${file}.bak
  713. done
  714. }
  715. di(){
  716. if null type git
  717. then
  718. git --git-dir= diff "$@"
  719. ___diffcmd="git --git-dir= diff"
  720. else
  721. if type colordiff >/dev/null 2>&1 && test $TERM != dumb
  722. then
  723. ___diffcmd=colordiff
  724. else
  725. ___diffcmd=diff
  726. fi
  727. ${___diffcmd} -u "$@" | ${PAGER}
  728. fi
  729. }
  730. tb(){
  731. __datenum=`date +%Y%m%d-%H%M%S`
  732. __tb="$HOME/.var/tb/$__datenum"
  733. mkdir -p "$__tb"
  734. mv "$@" "$__tb"
  735. }
  736. mkdd(){
  737. _d=`date +%Y%m%d-%H%M%S` && \
  738. mkdir -p "$_d"
  739. }
  740. mkcd(){
  741. if test -z "$1"
  742. then
  743. echo "mkcd: usage: mkcd <dir>"
  744. return 1
  745. elif test -d "$1"
  746. then
  747. echo "Dir \"$1\" already exists."
  748. else
  749. mkdir -p "$1"
  750. echo "Dir \"$1\" created."
  751. fi
  752. cd "$1"
  753. }
  754. mkcdd(){
  755. # make and change date directory
  756. _d=`date +%Y%m%d-%H%M%S` && \
  757. mkcd "$_d"
  758. }
  759. if test -n "$TMUX" && null type reattach-to-user-namespace
  760. then
  761. alias pbpaste="reattach-to-user-namespace pbpaste"
  762. alias pbcopy="reattach-to-user-namespace pbcopy"
  763. fi
  764. catclip(){
  765. if $iswindows
  766. then
  767. cat /dev/clipboard | tr -d \\r
  768. elif $isdarwin
  769. then
  770. pbpaste
  771. else
  772. xclip -o -selection "clipboard"
  773. fi
  774. }
  775. setclip(){
  776. if test $# -eq 0
  777. then
  778. exec 3<&0
  779. else
  780. exec 3<<__EOF__
  781. `cat "$@"`
  782. __EOF__
  783. fi
  784. if $iswindows
  785. then
  786. 0<&3 sed -e 's/$/\r/' | tee /dev/clipboard
  787. elif $isdarwin
  788. then
  789. pbcopy 0<&3
  790. else
  791. 0<&3 xclip -i -f -selection "primary" | \
  792. xclip -i -f -selection "clipboard"
  793. fi
  794. exec 3<&-
  795. }
  796. open_file(){
  797. if $iscygwin
  798. then
  799. cygstart "$@"
  800. elif $ismsys
  801. then
  802. cmd.exe //c start "" "$@"
  803. elif $isdarwin
  804. then
  805. touch "$@"
  806. open "$@"
  807. elif $islinux
  808. then
  809. touch "$@"
  810. if null type pcmanfm; then
  811. LC_MESSAGES= pcmanfm "$@"
  812. else
  813. LC_MESSAGES= xdg-open "$@" &
  814. fi
  815. else
  816. cat "$@"
  817. fi
  818. }
  819. o(){
  820. if test $# -eq 0
  821. then
  822. open_file .
  823. else
  824. for f in "$@"
  825. do
  826. open_file "$(realpath "$f")"
  827. done
  828. fi
  829. }
  830. convmv_sjis2utf8_test(){
  831. convmv -r -f sjis -t utf8 *
  832. }
  833. convmv_sjis2utf8_notest(){
  834. convmv -r -f sjis -t utf8 * --notest
  835. }
  836. #################################################
  837. ## pastebin services
  838. ## https://wiki.archlinux.org/index.php/List_of_Applications/Internet#Pastebin_clients
  839. sprunge(){
  840. # http://sprunge.us
  841. if test -z "$1"
  842. then
  843. curl -F 'sprunge=<-' http://sprunge.us
  844. else
  845. curl http://sprunge.us/$1
  846. fi
  847. }
  848. dpaste(){
  849. # http://dpaste.de
  850. if test -z "$1"
  851. then
  852. curl -F 'content=<-' https://dpaste.de/api/
  853. echo
  854. else
  855. curl https://dpaste.de/$1/raw/
  856. fi
  857. }
  858. ######################################
  859. ## Prompt Settings
  860. __my_moc_state(){
  861. type mocp >/dev/null 2>&1 || return
  862. test "`mocp -Q %state 2>/dev/null`" = PLAY || return
  863. printf "$1" "`mocp -Q %title 2>/dev/null`"
  864. }
  865. __my_parse_svn_branch() {
  866. ___svn_url=$(LANG=C svn info 2>/dev/null | sed -ne 's#^URL: ##p')
  867. ___svn_repository_root=$(LANG=C svn info 2>/dev/null | \
  868. sed -ne 's#^Repository Root: ##p')
  869. echo ${___svn_url} | sed -e 's#^'"${___svn_repository_root}"'##g' | \
  870. awk '{print $1}'
  871. }
  872. __my_svn_ps1(){
  873. if svn status >/dev/null 2>&1
  874. then
  875. ___svn_branch=$(__my_parse_svn_branch)
  876. test -n "${___svn_branch}" && printf "$1" "{$___svn_branch}"
  877. fi
  878. }
  879. __my_battery_status(){
  880. ___dir=/sys/class/power_supply/BAT0
  881. if test -d $___dir && test -r $___dir/status && test -r $___dir/charge_full && \
  882. test -r $___dir/charge_now
  883. then
  884. ___st=$(cat $___dir/status)
  885. ___full=$(cat $___dir/charge_full)
  886. ___now=$(cat $___dir/charge_now)
  887. ___rate=$(expr "$___now" \* 100 / "$___full")
  888. printf "$1" "${___st}:${___rate}%"
  889. fi
  890. }
  891. alias bat='__my_battery_status %s\\n'
  892. __my_ps1_scale(){
  893. if null type stty && ! $ismsys
  894. then
  895. echo "[LxC:`stty size | tr -d $'\n' | tr " " x`]"
  896. fi
  897. }
  898. __my_ps1_tmux(){
  899. null type tmux || return $last
  900. ___tmuxc="$(tmux display -p '#S:#I:#W.#P' 2>/dev/null)"
  901. test -n "$TMUX" && echo "[TMUX:$___tmuxc]"
  902. }
  903. __my_ps1_moc(){
  904. __my_moc_state "[MOC:%s]"
  905. }
  906. echo BBB
  907. for f in /usr/share/git/git-prompt.sh \
  908. /Applications/Xcode.app/Contents/Developer/usr/share/git-core/git-prompt.sh \
  909. /usr/local/opt/bash-git-prompt/share/gitprompt.sh \
  910. "`brew --prefix 2>/dev/null`"/etc/bash_completion.d/git-prompt.sh \
  911. /usr/share/git-core/contrib/completion/git-prompt.sh \
  912. /usr/local/share/git-core/contrib/completion/git-prompt.sh \
  913. /etc/bash_completion.d/git-prompt \
  914. /opt/local/share/git-core/git-prompt.sh \
  915. /opt/local/share/doc/git-core/contrib/completion/git-prompt.sh
  916. do
  917. if test -r "$f" && ($inbash || $inzsh)
  918. then
  919. echo Srouce $f
  920. fi
  921. done
  922. export GIT_PS1_SHOWDIRTYSTATE=t
  923. export GIT_PS1_SHOWUPSTREAM=t
  924. __my_ps1_git(){
  925. null type __git_ps1 || return $last
  926. null git rev-parse --git-dir >/dev/null 2>&1 || return $last
  927. __git_ps1 "[GIT:$(__safe_run git config --get user.name):%s]"
  928. }
  929. __printf_ipaddr(){
  930. # ipaddress <fmt>
  931. type ip >/dev/null 2>&1 || return 1
  932. ___ip=$(LANG=C ip addr show scope global | \
  933. \grep --color=never --only-matching 'inet [^ ]*' | cut -d " " -f 2)
  934. test -n "$___ip" && printf "$1" $___ip
  935. }
  936. alias addr="__printf_ipaddr '%s'"
  937. __my_ps1_ipaddr(){
  938. ! $iswindows && __printf_ipaddr '[Addr:%s]'
  939. }
  940. __my_ps1_bttry(){
  941. ___bst="$__homerun/batterystatus"
  942. if test -z "$DISPLAY" && ! $iswindows
  943. then
  944. test -f $___bst && ___bstr="$(cat $___bst)"
  945. test -n "$___bstr" && ! echo $___bstr | grep 100 >/dev/null 2>&1 && \
  946. echo "[Battery:${___bstr}]"
  947. __my_battery_status %s >$___bst &
  948. fi
  949. }
  950. __my_ps1_memo(){
  951. test -f memo.txt && echo "m:$(echo $(wc -c memo.txt) | cut -f 1 -d " ")"
  952. }
  953. __my_ps1_dirs(){
  954. dirs | wc -l
  955. }
  956. __my_ps1_jobs(){
  957. # __my_ps1_jobs [<num>]
  958. if test -n "$1"
  959. then
  960. jobs="$1"
  961. else
  962. jobs="`jobs | wc -l`"
  963. fi
  964. if test "$jobs" -gt 0
  965. then
  966. echo "JOBS:$jobs"
  967. fi
  968. }
  969. __my_ps1_dollar(){
  970. if test -z "$SHLVL"
  971. then
  972. printf "$1"
  973. else
  974. perl -e 'while($ARGV[0]-- > 0){print "$ARGV[1]";}' $SHLVL "$1"
  975. fi
  976. }
  977. __my_alert_fail(){
  978. test $laststatus -eq 0 || \
  979. echo "STATUS:${laststatus}"
  980. }
  981. # About ansi escape sequences
  982. # http://archive.linux.or.jp/JF/JFdocs/Bash-Prompt-HOWTO-5.html
  983. # http://www.grapecity.com/japan/powernews/column/clang/047/page02.htm
  984. if $inbash || $inzsh
  985. then
  986. if $inzsh
  987. then
  988. __attr_beg=$'%{\033['
  989. __attr_end='m%}'
  990. else
  991. __attr_beg='\[\033['
  992. __attr_end='m\]'
  993. fi
  994. __color_default="${__attr_beg}0${__attr_end}"
  995. __color_black="${__attr_beg}0;30${__attr_end}"
  996. __color_red="${__attr_beg}0;31${__attr_end}"
  997. __color_green="${__attr_beg}0;32${__attr_end}"
  998. __color_yellow="${__attr_beg}0;33${__attr_end}"
  999. __color_blue="${__attr_beg}0;34${__attr_end}"
  1000. __color_magenta="${__attr_beg}0;35${__attr_end}"
  1001. __color_cyan="${__attr_beg}0;36${__attr_end}"
  1002. __color_white="${__attr_beg}0;37${__attr_end}"
  1003. __color_light_black="${__attr_beg}1;30${__attr_end}"
  1004. __color_light_red="${__attr_beg}1;31${__attr_end}"
  1005. __color_light_green="${__attr_beg}1;32${__attr_end}"
  1006. __color_light_yellow="${__attr_beg}1;33${__attr_end}"
  1007. __color_light_blue="${__attr_beg}1;34${__attr_end}"
  1008. __color_light_magenta="${__attr_beg}1;35${__attr_end}"
  1009. __color_light_cyan="${__attr_beg}1;36${__attr_end}"
  1010. __color_light_white="${__attr_beg}1;37${__attr_end}"
  1011. __color_bg_black="${__attr_beg}40${__attr_end}"
  1012. __color_bg_red="${__attr_beg}41${__attr_end}"
  1013. __color_bg_green="${__attr_beg}42${__attr_end}"
  1014. __color_bg_yellow="${__attr_beg}43${__attr_end}"
  1015. __color_bg_blue="${__attr_beg}44${__attr_end}"
  1016. __color_bg_magenta="${__attr_beg}45${__attr_end}"
  1017. __color_bg_cyan="${__attr_beg}46${__attr_end}"
  1018. __color_bg_white="${__attr_beg}47${__attr_end}"
  1019. __attr_underline="${__attr_beg}4${__attr_end}"
  1020. __attr_reverse="${__attr_beg}7${__attr_end}"
  1021. __attr_bold="${__attr_beg}1${__attr_end}"
  1022. fi
  1023. # NOTE: tput is another easy way to set colors and background
  1024. # For example, "$(tput setab 4)text$(tput sgr0)" print text with background
  1025. # color blue.
  1026. # http://www.ibm.com/developerworks/jp/linux/aix/library/au-learningtput/index.html
  1027. if test "$TERM" != dumb
  1028. then
  1029. __my_c1="$__attr_bold$__attr_underline" # color for PWD
  1030. __my_c2="$__attr_bold$__attr_underline" # color for user and hostname
  1031. # color for ::
  1032. if test -z "$_HOSTCOLOR_1"
  1033. then
  1034. # default color used by tmux status line
  1035. _HOSTCOLOR_1=green
  1036. fi
  1037. eval "__my_c4=\${__color_light_${_HOSTCOLOR_1}}"
  1038. __my_c5="$__color_black$__color_bg_white" # color for SCR
  1039. __my_cdef="$__color_default"
  1040. fi
  1041. if $inbash
  1042. then
  1043. __my_ps1_sh="[BASH:$BASH_VERSION]"
  1044. elif $inzsh
  1045. then
  1046. __my_ps1_sh="[ZSH:$ZSH_VERSION]"
  1047. fi
  1048. __my_ps1_info1(){
  1049. # first line of PS1
  1050. echo "${__my_ps1_sh}$(__my_ps1_scale)$(__my_ps1_git)$(__my_ps1_bttry)$(__my_ps1_moc)"
  1051. }
  1052. test -n "$__MY_SCRIPT" && \
  1053. __my_ps1_str_scr="SCR"
  1054. test -n "$SSH_CONNECTION" && \
  1055. __my_ps1_str_ssh="SSH"
  1056. test -n "$__MY_DTACH" && \
  1057. __my_ps1_str_dt="DT:`basename "$__MY_DTACH$"`"
  1058. __my_ps1_info2(){
  1059. # second line of PS1
  1060. echo $(__my_ps1_memo) $(__my_ps1_jobs) ${__my_ps1_str_scr} \
  1061. ${__my_ps1_str_ssh} ${__my_ps1_str_dt} $(__my_alert_fail) \
  1062. | sed -e 's/ /|/g'
  1063. }
  1064. __my_ps1_beg="${__my_c4}:: ${__my_cdef}"
  1065. __my_ps1_save_pos="\[\033[s\]"
  1066. __my_ps1_restore_pos="\[\033[u\]"
  1067. __my_ps1_move_rightmost="\[\033[\$(tput cols)C\]"
  1068. __my_ps1_move_15left="\[\033[15D\]"
  1069. # collapse when command line is too long and try to write over this string
  1070. # __my_ps1_right="${__my_ps1_save_pos}${__my_ps1_move_rightmost}"
  1071. # ${__my_ps1_move_15left}\D{%Y/%m/%d %H:%M}${__my_ps1_restore_pos}
  1072. if $inzsh
  1073. then
  1074. PROMPT="\
  1075. ${__my_ps1_beg}[${__my_c2}%n@%M${__my_cdef}:${__my_c1}%~/${__my_cdef}]\$(__my_ps1_info1)
  1076. ${__my_ps1_beg}\$(__my_ps1_info2) $(__my_ps1_dollar %#) "
  1077. RPROMPT="%D{%Y/%m/%d %H:%M}"
  1078. elif $inbash
  1079. then
  1080. PS1="\
  1081. ${__my_ps1_beg}[${__my_c2}\u@\H${__my_cdef}:${__my_c1}\w/${__my_cdef}]\$(__my_ps1_info1)\n\
  1082. ${__my_ps1_beg}\D{%Y/%m/%d %H:%M} \$(__my_ps1_info2)${__my_ps1_right} $(__my_ps1_dollar \\$) "
  1083. else
  1084. true
  1085. # PS1="$(printf $(whoami)@$(hostname)$ )"
  1086. fi
  1087. ###################################
  1088. # set header and titles
  1089. __my_set_header_line(){
  1090. # save current position
  1091. printf "\033[s"
  1092. # move to 0,0
  1093. printf "\033[0;0H"
  1094. # clear curent to eol
  1095. printf "\033[K"
  1096. # inverse color
  1097. printf "\033[7m"
  1098. printf "$1"
  1099. # restore color
  1100. printf "\033[0m"
  1101. # restore saved position
  1102. printf "\033[u"
  1103. }
  1104. __my_set_screen_name(){
  1105. # set window name
  1106. if test -n "$TMUX" && test -z "$INSIDE_EMACS"
  1107. then
  1108. echo -ne "\033k$1\033\\"
  1109. fi
  1110. }
  1111. __my_set_title(){
  1112. case $TERM in
  1113. (rxvt*|xterm*|aterm|screen*)
  1114. test -t 1 &&
  1115. test -z "$EMACS" &&
  1116. echo -n -e "\033]0;$1\007"
  1117. ;;
  1118. esac
  1119. }
  1120. if test -n "$TMUX"
  1121. then
  1122. # running tmux locally
  1123. __terminal_title="\$(basename \${PWD})"
  1124. elif test -n "$SSH_CONNECTION" && expr "$TERM" : '^screen' >/dev/null
  1125. then
  1126. # ssh connect from tmux terminal
  1127. __terminal_title="`whoami`@`hostname`:\$(basename \${PWD})"
  1128. else
  1129. __terminal_title="`whoami`@`hostname`:\${PWD}"
  1130. fi
  1131. if $inzsh
  1132. then
  1133. precmd(){
  1134. laststatus=$?
  1135. eval __my_set_title ${__terminal_title}
  1136. }
  1137. else
  1138. if test -n "$PROMPT_COMMAND" && ! expr "$PROMPT_COMMAND" : '.*; *$' >/dev/null
  1139. then
  1140. PROMPT_COMMAND="${PROMPT_COMMAND};"
  1141. fi
  1142. if test -n "$PROMPT_COMMAND"
  1143. then
  1144. PROMPT_COMMAND="laststatus=\$?;${PROMPT_COMMAND}__my_set_title \"${__terminal_title}\";"
  1145. else
  1146. PROMPT_COMMAND="laststatus=\$?;__my_set_title \"${__terminal_title}\";"
  1147. fi
  1148. fi
  1149. laststatus=0